<template>
  <div>
    <v-container>
      <v-card class="elevation-4 card">
 
        <div class="toolBar">

          <v-toolbar-title >
            <span class="primary--text"><b>Avaliações</b></span>
          </v-toolbar-title>
        
          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>


          <!-- <div class="navTests" > -->
            <v-btn
              v-if="userCanDeleteTest"
              small
              color="primary"
              :class="actualNav == 'ShowTests' ? 'warning primary--text mr-4' : 'mr-4'"
              elevation="0"
              @click="handleViewTests"

            >
              Provas
            </v-btn>
            <v-btn
              v-if="userRole == 'admin'"
              small
              color="primary"
              :class="actualNav == 'AreasQuestionBank' ? 'warning primary--text mr-4' : 'mr-4'"
              :style="getResponsiveButtonStyles"
              elevation="0"
              @click="handleAreas"
            >
              Áreas de Conhecimento
            </v-btn>
            <v-btn
              v-if="userCanDeleteTest"
              small
              color="primary"
              :class="actualNav == 'QuestionBank' ? 'warning primary--text mr-4 ' : 'mr-4 '"
              cols="10"
              elevation="0"
              @click="handleQuestionBank"
            >
              Banco de Questões
            </v-btn>
          <!-- </div> -->
        </div>

        <!-- Rota interna -->
        <router-view
          :refreshByNewTest="refreshByNewTest"
          :userRole="userRole"
          @addNewTest="addNewTest"
        />
      </v-card>
    </v-container>
    <!-- INICIO DOS DIALOGS -->
    <v-dialog
      v-model="dialogManageTest"
      :width="widthManageTestDialog"
      @keydown.esc="closeDialogManageTest"
      @click:outside="closeDialogManageTest"
    >
      <ManageTests
        ref="refTest"
        :manageTest="manageTest"
        :itemToEdit="itemToEdit"
        @handleClose="closeDialogManageTest"
        @addTest="addTest"
        @goTab0="widthManageTestDialog = '800px'"
        @goTab1="widthManageTestDialog = '95%'"
      />
    </v-dialog>
  </div>
</template>

<script>
import Ehq from '../services/ehq'
import ManageTests from '../components/ehqModule/admin/ManageTests.vue'

export default {
  components: { ManageTests },
  name: 'Tests',
  data: () => ({
    userCanReadAll: false,
    userCanAddTest: false,
    userCanDeleteTest: false,
    userCanUpdateTest: false,
    userCanMonitoring: false,
    userCanResolveTest: false,
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToView: {},
    itemToEdit: {},
    manageTest: 'add', //add or edit
    dialogManageTest: false,
    userInfo: {},
    userRole: '',
    widthManageTestDialog: '800px',
    refreshByNewTest: 0,
    actualNav: '',
  }),
  async created() {
    this.actualNav = this.$route.name
    await this.checkIsAdmin()
    await this.checkPrivileges()
  },

  methods: {
    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },

    async checkIsAdmin() {
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == 'createPrivilege') {
          check = true
          return
        }
      })
      if (check) this.userRole = 'admin'
    },

    async checkPrivileges() {
      await this.userCheckPrivileges('userCanReadAll', 'ehqTestRead')
      await this.userCheckPrivileges('userCanAddTest', 'ehqTestCreate')
      await this.userCheckPrivileges('userCanDeleteTest', 'ehqTestDelete')
      await this.userCheckPrivileges('userCanUpdateTest', 'ehqTestUpdate')
      await this.userCheckPrivileges('userCanMonitoring', 'ehqMonitorActions')
      await this.userCheckPrivileges('userCanResolveTest', 'ehqStudentActions')
    },

    //nova questão
    handleViewTests() {
      this.actualNav = this.$route.name
      if (this.actualNav !== 'ShowTests') {
        this.$router.push({ name: 'ShowTests' })
        this.actualNav = this.$route.name
      }
    },

    addNewTest() {
      this.manageTest = 'add'
      this.dialogManageTest = true
    },

    handleQuestionBank() {
      this.actualNav = this.$route.name
      if (this.actualNav !== 'QuestionBank') {
        this.$router.push({ name: 'QuestionBank' })
        this.actualNav = this.$route.name
      }
    },

    handleAreas() {
      this.actualNav = this.$route.name
      if (this.actualNav !== 'AreasQuestionBank') {
        this.$router.push({ name: 'AreasQuestionBank' })
        this.actualNav = this.$route.name
      }
    },

    // métodos p/ nova questão e editar questão
    closeDialogManageTest() {
      this.$refs.refTest.resetData()
      this.dialogManageTest = false
      this.manageTest = 'add'
      this.itemToEdit = { questions: [] }
    },

    //add novo teste
    async addTest(item) {
      item.questions.forEach((question) => {
        question.author = `${question.author.name} ${question.author.surname}`
      })
      let author = await this.$getItem('userInfo')
      let initialDate = new Date(item.initialDate)
      let endDate = new Date(item.endDate)
      // let questions = []
      // item.questions.forEach((question) => {
      //   questions.push({ id: question.id, weight: Number(question.weight) })
      // })
      item.monitors.push(author.id) // adicionar o criador do teste como monitor

      let data = {
        author: author.id,
        instructions: item.instructions,
        initialDate: initialDate.toISOString(),
        endDate: endDate.toISOString(),
        title: item.title,
        questions: item.questions,
        monitors: item.monitors,
      }

      await this.createTest(data)

      this.closeDialogManageTest()
      this.refreshByNewTest++
    },

    // Integração BackEnd

    async createTest(data) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('ehqTestRead').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Ehq.createTest(entityId, actionId, data)
        if (req.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Prova foi <b>criada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}

.navTests > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.navTests {
  display: flex;
  gap: 4px;
  flex-wrap: wrap;
  margin: 4px 0;
}

.toolBar > .v-btn:hover{
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.toolBar {
  padding-top: 15px;
  padding-left: 17px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  flex-wrap: wrap;
  gap: 5px
}

.ehqTable > .v-icon:hover {
  color: #ffc107 !important;
}

.ehqTable > .v-icon,
.v-btn {
  margin-right: 8px;
}

.noTests {
  font-size: 1rem;
  min-height: 100px;
  text-align: center;
}
.noTests > b {
  padding-left: 4px;
  padding-right: 4px;
}
</style>
